#ifndef __cast_128_h__
#define __cast_128_h__

/*
 * $Id: cast-128.h,v 1.1.1.1 1999/10/15 22:49:23 nmav Exp $
 *
 *	CAST-128 in C
 *	Written by Steve Reid <sreid@sea-to-sky.net>
 *	100% Public Domain - no warranty
 *	Released 1997.10.11
 */

#ifdef __cplusplus
extern "C" {
#endif

#define CAST_MIN_KEYSIZE 5
#define CAST_MAX_KEYSIZE 16
#define CAST_BLOCKSIZE 8

#define CAST_SMALL_KEY 10
#define CAST_SMALL_ROUNDS 12
#define CAST_FULL_ROUNDS 16

struct cast_key {
	uint32 xkey[32];	/* Key, after expansion */
	unsigned rounds;		/* Number of rounds to use, 12 or 16 */
};

void _zcrypt_cast_setkey(struct cast_key *key,uint8 *rawkey,unsigned keybytes);
void _zcrypt_cast_encrypt(struct cast_key *key,uint8 *block);
void _zcrypt_cast_decrypt(struct cast_key *key,uint8 *block);

#ifdef __cplusplus
}
#endif
#endif /* !__cast_128_h__ */

