#ifndef __rijndael_h__
#define __rijndael_h__

#ifdef __cplusplus
extern "C" {
#endif

typedef struct rijndael_instance {
	int Nk,Nb,Nr;
	uint8 fi[24],ri[24];
	uint32 fkey[120];
	uint32 rkey[120];
} RI;

void _zcrypt_rijndael_set_key(RI* rinst, int nb,int nk,uint8 *key);
  /* blocksize=32*nb bits. Key=32*nk bits */
  /* currently nb,bk = 4, 6 or 8          */
  /* key comes as 4*Nk bytes              */
  /* Key Scheduler. Create expanded encryption key */
  
void _zcrypt_rijndael_encrypt(RI* rinst, uint8 *buff);
void _zcrypt_rijndael_decrypt(RI* rinst, uint8 *buff);
void _zcrypt_rijndael_gentables(void);

#ifdef __cplusplus
}
#endif

#endif /* !__rijndael_h__ */
