#ifndef __swap_h__
#define __swap_h__

#ifdef __cplusplus
extern "C" {
#endif

uint16 byteswap_16(uint16 x);

#define FAST

#ifdef FAST
	#define rotl(x,n)   (((x) << ((uint32)(n))) | ((x) >> (32 - (uint32)(n))))
	#define rotr(x,n)   (((x) >> ((uint32)(n))) | ((x) << (32 - (uint32)(n))))
	#define rotl16(x,n)   (((x) << ((uint16)(n))) | ((x) >> (16 - (uint16)(n))))
	#define rotr16(x,n)   (((x) >> ((uint16)(n))) | ((x) << (16 - (uint16)(n))))
	#define byteswap(x)	((rotl(x, 8) & 0x00ff00ff) | (rotr(x, 8) & 0xff00ff00))
#else
	uint16 rotl16(uint16 v, uint16 cnt);
	uint16 rotr16(uint16 v, uint16 cnt);
	uint32 rotl(uint32 v, uint32 cnt);
	uint32 rotr(uint32 v, uint32 cnt);
	uint32 byteswap(uint32 x);
#endif

#ifdef __cplusplus
}
#endif
#endif /* !__swap_h__ */
