#ifndef __version_h__
#define __version_h__
/*
 * libzdt - zdt's own C Library.
 * Copyright (C) 1999,2000 Jeremy Tregunna. All rights reserved.
 *
 * libzdt is distributed under a modified version of the BSD license.
 * You should have received a copy of this license in the Documentation
 * directory.
 */
#include <zdt/Types.h>
#include <zdt/ZObject.h>

#ifdef __cplusplus
extern "C" {
#endif

#define __libzdtVersionMajor__ "4"
#define __libzdtVersionMinor__ "0"
#define __libzdtVersionPrepatch__ "0"
#define __libzdtVersionPlatform__ "GNU/Linux"
#define __libzdtVersionArchitecture__ "x86"

#undef __libzdtVersion__
#define __libzdtVersion__ "libzdt v" __libzdtVersionMajor__ "." __libzdtVersionMinor__ "." __libzdtVersionPrepatch__ "-" __libzdtVersionArchitecture__ "_" __libzdtVersionPlatform__

@interface Version : ZObject

- (const char *)FullVersion;
- (const char *)MajorVersion;
- (const char *)MinorVersion;
- (const char *)PrePatchVersion;
- (const char *)PlatformVersion;
- (const char *)ArchitectureVersion;

@end

#endif /* !__version_h__ */
