/*
 * libzdt - zdt's own C Library.
 * Copyright (C) 1999,2000 Jeremy Tregunna. All rights reserved.
 *
 * libzdt is distributed under a modified version of the BSD license.
 * You should have received a copy of this license in the Documentation
 * directory.
 */
#include <zdt/Types.h>
#include <zdt/ZSocket.h>
#include <zdt/ZObject.h>

/* Standard includes */
#include <stdio.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <netdb.h>

@implementation ZSocket

/* Make a connection to a remote host with a specific port. */
- (int)ConnectToHostWithPort:(char *)aHost port:(int16)aPort
{
	struct sockaddr_in client;
	struct in_addr inaddr;
	struct hostent *host;
	int fd;

	/* Get hostname (if aHost is an IP address), else lookup the hostname. */
	if (inet_aton(aHost,&inaddr)) {
		host = gethostbyaddr((char *)&inaddr,sizeof(inaddr),AF_INET);
	}
	else {
		host = gethostbyname(aHost);
	}

	if (!host) {
		fprintf(stderr,"Unable to find host \"%s\"\n",aHost);
		return 0;
	}

	fd = socket(PF_INET,SOCK_STREAM,0);

	client.sin_family = AF_INET;
	client.sin_port = htons(aPort);

	memcpy(&client.sin_addr,host->h_addr_list[0],sizeof(client.sin_addr));

	connect(fd,(struct sockaddr *)&client,sizeof(client));

	return fd;
}



@end
